/*
 *************************************************************************************************************
 * PickSortAusnahme.h       
 *
 * Das PickSort-Projekt-eigene simple Ausnahmesystem.
 *
 * Copyright (C) Andreas Eichendorf 2014 <PickSort@Andreas-Petra.de>            
 *************************************************************************************************************
 */


#ifndef PICKSORTAUSNAHME_H
#define PICKSORTAUSNAHME_H


#include <gtkmm.h>

#include "PickSortGenerelles.h"


class AusnahmeClass
{
 public:
  // Hier lassen sich die IDs sichtbar zentral ablegen:
  enum AusnahmeID {ALLGEMEIN,
                   FILEHANDLINGEXIT,
                   FILEHANDLINGKEINNAME,
                   FILEHANDLINGKEINOEFFNEN};
  // Werfen einer allgemeinen Ausnahme:
  AusnahmeClass();
  // Werfen einer spezialisierten Ausnahme:
  AusnahmeClass(AusnahmeID ID, const Glib::ustring& Text);
  virtual ~AusnahmeClass();
  // Text der Ausnahme holen
  const Glib::ustring& GetAusnahmeText() const;
  int GetAusnahmeID() const;
 private:
  AusnahmeID AusnahmeNummer;
  Glib::ustring AusnahmeText;
};  // class AusnahmeClass


#endif  // PICKSORTAUSNAHME_H


/*
 * PickSortAusnahme.h ****************************************************************************************
 */
