/*
 *************************************************************************************************************
 * PickSortEditierspalte.h       
 *
 * Die Struktur einer editierbaren Spalte, die Bilder aufnehmen kann.
 *
 * Copyright (C) Andreas Eichendorf 2014 <PickSort@Andreas-Petra.de>            
 *************************************************************************************************************
 */


#ifndef PICKSORTEDITIERSPALTE_H
#define PICKSORTEDITIERSPALTE_H


#include <gtkmm.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <string>

#include "PickSortElement.h"
#include "PickSortFilehandling.h"
#include "PickSortFortschritt.h"
#include "PickSortGenerelles.h"


class EditierspalteEventBoxClass : public Gtk::EventBox, public GenerellesClass
{
 public:
  EditierspalteEventBoxClass();
  virtual ~EditierspalteEventBoxClass();
  void EditierspalteNeu();
  void EditierspalteLaden();
  void EditierspalteSpeichern();
  void EditierspalteBenennen();
  void EditierspalteFiltern();
  void EditierspalteSortieren();
  void EditierspaltePraesentieren();
  void EditierspalteElementRechtsDrehen();
  void EditierspalteElementLinksDrehen();
  void EditierspalteElementBetrachten();
  void EditierspalteElementEditieren();
  bool GetUmbenanntUmbewertetGedreht();
  bool GetSpalteIstLeer();
 protected:
  // Kinderwidgets:  
  Gtk::Label EditierspalteLabel;  
  // Wird beim Einlesen der Files dynamisch allokiert und in den Grid-Container geladen:
  ElementEventBoxClass* EditierspalteElement;
  // Den eigentlichen Spalteninhalt als Zeiger fuehren, weil unter gtkmm3 nur so ein vollstaendiges Loeschen
  // moeglich ist, weil es ja Box nicht mehr und stattdessen Grid gibt und weil die Container-
  // Methoden der Elementverwaltung beim Uebergang von gtkmm2 nach gtkmm3 verschwunden sind:
  Gtk::Grid* EditierspalteGrid;
  // Aus dem ScrolledWindow heraus kann man nicht remove() geben, weil so der Viewport geloescht wird.
  // Daher baue ich noch einen Rahmen ein:
  Gtk::Frame EditierspalteRahmen;
  Gtk::ScrolledWindow EditierspalteScrolledWindow;
  Gtk::Grid EditierspalteRahmenGrid;
  // Signalhandler:
  bool EditierspalteButtonPressEventHandler(GdkEventButton* EditierspalteButtonPressEvent);
 private:
  // Testet, ob das neu zu ladende Verzeichnis schon in einer anderen Spalte geladen wurde. Dies waere
  // problematisch, weil Spalten und Verzeichnis unsynchron zueinander werden koennten:
  bool EditierspalteVerzeichnisDoppelt(EditierspalteEventBoxClass*  EditierspalteAktuellSpeicher,
                                       const Glib::ustring& NeuesVerzeichnis);
  // Laedt die Files real in die Spalten. Ist nur ausgelagerter Code wegen besserer Uebersichtlichkeit:
  void EditierspalteFilesLaden(EditierspalteEventBoxClass*  EditierspalteAktuellSpeicher);
  // Der eigentliche Sortieralgorithmus ist in eine eigene Funktion gekapselt. Name == true: Es wird
  // nach dem Namen aufsteigend sortiert. Name != true: Es wird nach dem Datum aufsteigend sortiert:
  void SortierAlgorithmus(EditierspalteEventBoxClass* Editierspalte, bool IstName);
  // Halten der Spaltennamen = Verzeichnisnamen. Damit kein Verzeichnis doppelt geladen werden kann,
  // muss beim Laden die bereits geladenen Verzeichnisse abgefragt werden. Dies soll ohne Zutun der
  // aufrufenden Instanz der uebergeordneten Klasse gemacht werden. Methoden: static und std::vector: 
  static short EditierspalteAnzahl;
  short EditierspalteNummerHier;
  static std::vector<Glib::ustring> EditierspaltenNamen;
  // Hält die aktuelle Spalte: 
  static EditierspalteEventBoxClass* EditierspalteAktuell;
  // Verkettete Grafikelemente hier einhaengen:
  ElementEventBoxClass* Start;
  ElementEventBoxClass* Ende;
};  // class EditierspalteEventBoxClass


#endif  // PICKSORTEDITIERSPALTE_H

/*
 * PickSortEditierspalte.h ***********************************************************************************
 */
