/*
 *************************************************************************************************************
 * PickSortFortschritt.cpp     
 *
 * Der Fortschrittsbalken von PickSort im eigenen Dialogfeld.
 *
 * Copyright (C) Andreas Eichendorf 2014 <PickSort@Andreas-Petra.de>            
 *************************************************************************************************************
 */


#include "PickSortFortschritt.h"


FortschrittDialogClass::FortschrittDialogClass(const Glib::ustring& Titel, const Glib::ustring& Text)
: Dialog(Titel, false)
{
 FortschrittEnde = false;
 get_content_area()->set_border_width(10);
 get_content_area()->set_spacing(10);
 FortschrittLabel.set_text(Text);
 get_content_area()->pack_start(FortschrittLabel);   
 get_content_area()->pack_start(FortschrittProgressBar);
 add_button(Gtk::Stock::CANCEL, Gtk::RESPONSE_CANCEL);
 signal_response().connect(sigc::mem_fun(*this, &FortschrittDialogClass::FortschrittCancelSignalHandler));
 show_all();
}  // FortschrittDialogClass


FortschrittDialogClass::~FortschrittDialogClass()
{
 hide();
}  // ~FortschrittDialogClass


void FortschrittDialogClass::FortschrittCancelSignalHandler(int AntwortID)
{
 if (AntwortID == Gtk::RESPONSE_CANCEL)
  FortschrittEnde = true;
}  // CancelSignalHandler


void FortschrittDialogClass::SetFortschrittAnzeige(double AnteilNeu)
{
 FortschrittProgressBar.set_fraction(std::min(std::max(0.0, AnteilNeu), 1.0)); 
 // Haendisch die Bildschirmausgabe anschieben:
 while(Gtk::Main::events_pending())
  {
   // false: nicht auf geeignetes Event warten, sondern weitermachen, wenn kein Event da ist:
   Gtk::Main::iteration(false);
  } 
}  // SetFortschrittbalkenAnzeige


bool FortschrittDialogClass::GetFortschrittEndeAnforderung() const
{
 return FortschrittEnde;
}  // GetFortschrittEnde 


FortschrittDialogClass::FortschrittDialogClass(const FortschrittDialogClass& FortschrittDialogClassRValue)
{
}  // FortschrittDialogClass


FortschrittDialogClass& FortschrittDialogClass::operator=
                                              (const FortschrittDialogClass& FortschrittDialogClassRValue)
{
}  // operator=

/*
 * PickSortFortschritt.cpp ***********************************************************************************
 */
