/*
 *************************************************************************************************************
 * PickSortFortschritt.h       
 *
 * Der Fortschrittsbalken von PickSort im eigenen Dialogfeld.
 *
 * Copyright (C) Andreas Eichendorf 2014 <PickSort@Andreas-Petra.de>            
 *************************************************************************************************************
 */


#ifndef PICKSORTFORTSCHRITT_H
#define PICKSORTFORTSCHRITT_H


#include <gtkmm.h>
#include <iostream>

#include "PickSortGenerelles.h"


class FortschrittDialogClass : public Gtk::Dialog
{
 public:
  // Titel und Untertitel muessen eingegeben werden:
  FortschrittDialogClass(const Glib::ustring& Titel, const Glib::ustring& Text);
  virtual ~FortschrittDialogClass();
  // Setter:
  // Setzt die Balken auf eine gewuenschte Position:
  void SetFortschrittAnzeige(double Anteil);
  // Wenn der Benutzer es will, kann vorzeitig abgebrochen werden. Funktion erlaubt Polling durch
  // das aufrufende Programm:
  bool GetFortschrittEndeAnforderung() const;
 protected:
  // Kinderwidgets:
  Gtk::Label FortschrittLabel;
  Gtk::ProgressBar FortschrittProgressBar;
  void FortschrittCancelSignalHandler(int AntwortID);  
 private:
  FortschrittDialogClass(const FortschrittDialogClass& FortschrittDialogClassRValue);
  FortschrittDialogClass& operator=(const FortschrittDialogClass& FortschrittDialogClassRValue);
  
  bool FortschrittEnde;
};  // class FortschrittDialogClass


#endif  // PICKSORTFORTSCHRITT_H

/*
 * PickSortFortschritt.h *************************************************************************************
 */
