/*
 *************************************************************************************************************
 * PickSortHauptfenster.cpp     
 *
 * Das Hauptfenster von PickSort: Kopfzeile, Menue, Fortschrittsbalken.
 *
 * Copyright (C) Andreas Eichendorf 2014 <PickSort@Andreas-Petra.de>            
 *************************************************************************************************************
 */


#include "PickSortHauptfenster.h"


HauptfensterWindowClass::HauptfensterWindowClass()
{ 
 // Schliessen-Button [X] mit Benutzerabfrage ausstatten:
  signal_delete_event().connect
   (sigc::mem_fun(*this, &HauptfensterWindowClass::HauptfensterWindowSchliessenSignalHandler));
 // Hauptfenster:
 set_title("PickSort");
 set_icon_list(GenerellesPixelbuffersIcons);
 maximize();
 show();
 // Callback fuer die rechte Maustaste, die zum Popup-Menue fuehrt:
 HauptfensterPopupEventBox.signal_button_press_event().connect
  (sigc::mem_fun(*this, &HauptfensterWindowClass::PopupSignalHandler));
 // Fenster aufbauen:
 add(HauptfensterPopupEventBox);
 HauptfensterPopupEventBox.show();
 HauptfensterPopupEventBox.add(HauptfensterGrid);
 HauptfensterGrid.show();
 // Menuefeld:
 // Aufbau hier mit dem UIManager, was bei statischen Menues wohl gut funktioniert:
 // (Die RefPtr werden bei verlassen des letzten Scopes wohl von alleine deallokiert.)
 HauptfunktionenActionGroup = Gtk::ActionGroup::create();
  HauptfunktionenActionGroup->add(Gtk::Action::create("VerzeichnisAction", _("Directory")));
    VerzeichnisLadenAction = Gtk::Action::create("VerzeichnisNeuAction", _("new"));
    VerzeichnisLadenAction->set_sensitive(true);
    HauptfunktionenActionGroup->add(VerzeichnisLadenAction,
     sigc::mem_fun(*this, &HauptfensterWindowClass::VerzeichnisNeuSignalHandler));  
   VerzeichnisLadenAction = Gtk::Action::create("VerzeichnisLadenAction", _("load"));
    VerzeichnisLadenAction->set_sensitive(true);
    HauptfunktionenActionGroup->add(VerzeichnisLadenAction,
     sigc::mem_fun(*this, &HauptfensterWindowClass::VerzeichnisLadenSignalHandler));
   VerzeichnisSpeichernAction = Gtk::Action::create("VerzeichnisSpeichernAction", _("save"));
    VerzeichnisSpeichernAction->set_sensitive(true);
    HauptfunktionenActionGroup->add(VerzeichnisSpeichernAction,
     sigc::mem_fun(*this, &HauptfensterWindowClass::VerzeichnisSpeichernSignalHandler));  
  HauptfunktionenActionGroup->add(Gtk::Action::create("SpalteAction", _("Column")));
   SpalteFilternAction = Gtk::Action::create("SpalteFilternAction", _("filter"));     
    SpalteFilternAction->set_sensitive(true);
    HauptfunktionenActionGroup->add(SpalteFilternAction,
     sigc::mem_fun(*this, &HauptfensterWindowClass::SpalteFilternSignalHandler)); 
   SpalteSortierenAction = Gtk::Action::create("SpalteSortierenAction", _("sort"));
    SpalteSortierenAction->set_sensitive(true);
    HauptfunktionenActionGroup->add(SpalteSortierenAction,
     sigc::mem_fun(*this, &HauptfensterWindowClass::SpalteSortierenSignalHandler)); 
   SpalteBenennenAction = Gtk::Action::create("SpalteBenennenAction", _("name"));
    SpalteBenennenAction->set_sensitive(true);
    HauptfunktionenActionGroup->add(SpalteBenennenAction,
     sigc::mem_fun(*this, &HauptfensterWindowClass::SpalteBenennenSignalHandler));
   SpaltePraesentierenAction = Gtk::Action::create("SpaltePraesentierenAction", _("show"));               
    SpaltePraesentierenAction->set_sensitive(true);                                    
    HauptfunktionenActionGroup->add(SpaltePraesentierenAction,
     sigc::mem_fun(*this, &HauptfensterWindowClass::SpaltePraesentierenSignalHandler)); 
 HauptfunktionenActionGroup->add(Gtk::Action::create("BildAction", _("Picture"))); 
   BildRechtsDrehenAction = Gtk::Action::create("BildRechtsDrehenAction", _("rotate cw"));
    BildRechtsDrehenAction->set_sensitive(true);   
    HauptfunktionenActionGroup->add(BildRechtsDrehenAction,
     sigc::mem_fun(*this, &HauptfensterWindowClass::BildRechtsDrehenSignalHandler)); 
   BildLinksDrehenAction  = Gtk::Action::create("BildLinksDrehenAction", _("rotate ccw")); 
    BildLinksDrehenAction->set_sensitive(true);   
    HauptfunktionenActionGroup->add(BildLinksDrehenAction,
     sigc::mem_fun(*this, &HauptfensterWindowClass::BildLinksDrehenSignalHandler));
   BildBetrachtenAction = Gtk::Action::create("BildBetrachtenAction", _("view"));    
    BildBetrachtenAction->set_sensitive(true);                          
    HauptfunktionenActionGroup->add(BildBetrachtenAction,
     sigc::mem_fun(*this, &HauptfensterWindowClass::BildBetrachtenSignalHandler)); 
   BildBearbeitenAction = Gtk::Action::create("BildBearbeitenAction", _("edit"));
    BildBearbeitenAction->set_sensitive(true); 
    HauptfunktionenActionGroup->add(BildBearbeitenAction,
     sigc::mem_fun(*this, &HauptfensterWindowClass::BildBearbeitenSignalHandler));   
 HauptfunktionenActionGroup->add(Gtk::Action::create("BenutzerAction", _("User")));
   BenutzerInformierenAction = Gtk::Action::create("BenutzerInformierenAction", _("inform"));    
    BenutzerInformierenAction->set_sensitive(true);
    HauptfunktionenActionGroup->add(BenutzerInformierenAction,
     sigc::mem_fun(*this, &HauptfensterWindowClass::BenutzerInformierenSignalHandler));
   BenutzerEinweisenAction = Gtk::Action::create("BenutzerEinweisenAction", _("instruct"));    
    BenutzerEinweisenAction->set_sensitive(true);
    HauptfunktionenActionGroup->add(BenutzerEinweisenAction,
     sigc::mem_fun(*this, &HauptfensterWindowClass::BenutzerEinweisenSignalHandler)); 
 HauptfunktionenUIManager = Gtk::UIManager::create();
 HauptfunktionenUIManager->insert_action_group(HauptfunktionenActionGroup);    
 // Layout in der Menuezeile:
 Glib::ustring HauptfunktionenUIString = 
  "<ui>"
  " <menubar name='HauptfunktionenMenubar'>"
  "  <menu action='VerzeichnisAction'>"
  "   <menuitem action='VerzeichnisLadenAction'/>"
  "   <menuitem action='VerzeichnisSpeichernAction'/>"
  "   <menuitem action='VerzeichnisNeuAction'/>"    
  "  </menu>"  
  "  <menu action='SpalteAction'>"
  "   <menuitem action='SpalteFilternAction'/>"
  "   <menuitem action='SpalteSortierenAction'/>"
  "   <menuitem action='SpalteBenennenAction'/>"
  "   <menuitem action='SpaltePraesentierenAction'/>"
  "  </menu>"
  "  <menu action='BildAction'>"
  "   <menuitem action='BildRechtsDrehenAction'/>"
  "   <menuitem action='BildLinksDrehenAction'/>"
  "   <menuitem action='BildBetrachtenAction'/>"
  "   <menuitem action='BildBearbeitenAction'/>"
  "  </menu>"
  "  <separator/>"
  "  <separator/>"
  "  <menu action='BenutzerAction'>"
  "   <menuitem action='BenutzerInformierenAction'/>"
  "   <menuitem action='BenutzerEinweisenAction'/>"
  "  </menu>"
  " </menubar>"
  "</ui>";
 try
  {
   HauptfunktionenUIManager->add_ui_from_string(HauptfunktionenUIString);
  }
 catch(const Glib::Error& ExUndHopp)
  {
   std::cerr << "HauptfensterWindowClass: Unable to create user interface. => exit(1)" << std::endl;
   exit(1);
  }
 HauptfunktionenMenubar = Gtk::manage(HauptfunktionenUIManager->get_widget("/HauptfunktionenMenubar"));
 if (HauptfunktionenMenubar)
  {
   HauptfunktionenMenubar->set_hexpand(true);
   HauptfunktionenMenubar->set_vexpand(false);
   HauptfensterGrid.attach(*HauptfunktionenMenubar, 1, 1, 1, 1);
   HauptfunktionenMenubar->show();
  }
 // Popup-Menue - mit weniger Befehlen ausgestattet fuer weniger Mausklicks ohne Menuehierarchie.
 // Dynamische Menues sollen mit dem UIManager nicht so gut funktionieren, hier dann der ganz klassische Weg:
 VerzeichnisSpeichernMenuItem.set_label( _("Directory") + " " + _("save"));
  VerzeichnisSpeichernMenuItem.signal_activate().connect
   (sigc::mem_fun(*this, &HauptfensterWindowClass::VerzeichnisSpeichernSignalHandler));
  VerzeichnisSpeichernMenuItem.show();
  PopupMenue.append(VerzeichnisSpeichernMenuItem); 
 SpalteBenennenMenuItem.set_label(_("Column") + " " + _("name")); 
  SpalteBenennenMenuItem.signal_activate().connect
   (sigc::mem_fun(*this, &HauptfensterWindowClass::SpalteBenennenSignalHandler));
  SpalteBenennenMenuItem.show();
 PopupMenue.append(SpalteBenennenMenuItem);
 BildBetrachtenMenuItem.set_label(_("Picture") + " " + _("view"));
  BildBetrachtenMenuItem.signal_activate().connect
   (sigc::mem_fun(*this, &HauptfensterWindowClass::BildBetrachtenSignalHandler));
  BildBetrachtenMenuItem.show();
  PopupMenue.append(BildBetrachtenMenuItem); 
 BildBearbeitenMenuItem.set_label(_("Picture") + " " + _("edit"));
  BildBearbeitenMenuItem.signal_activate().connect
   (sigc::mem_fun(*this, &HauptfensterWindowClass::BildBearbeitenSignalHandler));
  BildBearbeitenMenuItem.show();
  PopupMenue.append(BildBearbeitenMenuItem);
 // Editierfeld:
 EditierfeldGrid.set_hexpand(true);
 EditierfeldGrid.set_vexpand(true);
 HauptfensterGrid.attach_next_to(EditierfeldGrid, *HauptfunktionenMenubar, Gtk::POS_BOTTOM, 1, 1);
 EditierfeldGrid.set_column_homogeneous(true);
 EditierfeldGrid.show();
 // Zuerst vier, spaeter einmal fast beliebig viele Editierspalten einsetzen.
 // (Managed Elemente, die werden dann mit dem Editierfeld deallokiert.)
 // Nur hier ist festgelegt, wieviel Spalten es werden sollen:
 for (int Zaehler = 1; Zaehler <= 4; ++Zaehler)
  { 
   EditierspalteEventBox = Gtk::manage(new EditierspalteEventBoxClass);
   EditierspalteEventBoxSpeicher.push_back(EditierspalteEventBox);
   EditierfeldGrid.attach(*EditierspalteEventBox, Zaehler, 1, 1, 1);
   EditierspalteEventBox->show();
  }
 // Gegen die Langeweile das Splash-Bildchen zeigen:
 BenutzerInformierenSignalHandler();
}  // PickSortHauptfensterWindowClass


HauptfensterWindowClass::~HauptfensterWindowClass()
{
}  // ~PickSortHauptfensterWindowClass


bool HauptfensterWindowClass::PopupSignalHandler(GdkEventButton* Event)
{
 if((Event->type == GDK_BUTTON_PRESS) && (Event->button == 3) )
  {
   PopupMenue.popup(Event->button, Event->time);  
   // Alles erledigt:
   return true;
  }
 else
  {
   // Hier weiterschalten - wer weiss, was da noch kommt:
   return false;
  }
}  // PopupSignalHandler


bool HauptfensterWindowClass::HauptfensterWindowSchliessenSignalHandler(GdkEventAny* Event)
{
 if (SchliessenRueckfrageNotwendig())
  {
   Gtk::MessageDialog *SortierDialog = 
    new Gtk::MessageDialog(_("Terminate without saving?"), false, Gtk::MESSAGE_QUESTION, Gtk::BUTTONS_YES_NO, true);
   SortierDialog->set_secondary_text
    (_("At least one column has been changed.\nTerminating without saving discards this preliminary work."));  
   if (SortierDialog->run() == Gtk::RESPONSE_NO)
    {
     // Das Hauptfenster wird vom Standard-Stop nicht geschlossen, da die Signalleitung unterbrochen wird:
     delete SortierDialog;
     return true;
    }
   else
    {
     // Fenster wird von der Standard-Routine geschlossen, da die Signalleitung nicht unterbrochen wird:
     delete SortierDialog;
     return false;
    }
  }
}  //HauptfensterWindowSchliessenSignalHandler


void HauptfensterWindowClass::VerzeichnisNeuSignalHandler()
{
 // Hier wird einfach die letzte allokierte EditierspalteEventBox angesprochen und die 
 // Editierspalten wissen dann von alleine, welche Spalte wirklich gemeint ist, naemlich
 // die aktuell ausgewaehlte. Trick: Static-Variable haelt die aktuelle Spalte:
 EditierspalteEventBox->EditierspalteNeu();
}  // VerzeichnisNeuSignalHandler


void HauptfensterWindowClass::VerzeichnisLadenSignalHandler()
{
 // Hier wird einfach die letzte allokierte EditierspalteEventBox angesprochen und die 
 // Editierspalten wissen dann von alleine, welche Spalte wirklich gemeint ist, naemlich
 // die aktuell ausgewaehlte. Trick: Static-Variable haelt die aktuelle Spalte:
 EditierspalteEventBox->EditierspalteLaden();
}  // VerzeichnisLadenSignalHandler


void HauptfensterWindowClass::VerzeichnisSpeichernSignalHandler()
{
 EditierspalteEventBox->EditierspalteSpeichern();
}  // VerzeichnisSpeichernSignalHandler


void HauptfensterWindowClass::SpalteFilternSignalHandler()
{
 EditierspalteEventBox->EditierspalteFiltern();
}  // SpalteFilternSignalHandler


void HauptfensterWindowClass::SpalteSortierenSignalHandler()
{
 EditierspalteEventBox->EditierspalteSortieren();
}  // SpalteSortierenSignalHandler


void HauptfensterWindowClass::SpalteBenennenSignalHandler()
{
 EditierspalteEventBox->EditierspalteBenennen();
}  // SpalteBenennenSignalHandler


void HauptfensterWindowClass::SpaltePraesentierenSignalHandler()
{
 EditierspalteEventBox->EditierspaltePraesentieren();
}  // SpaltePraesentierenSignalHandler


void HauptfensterWindowClass::BildRechtsDrehenSignalHandler()
{
 EditierspalteEventBox->EditierspalteElementRechtsDrehen();
}  // BildRechtsDrehenSignalHandler


void HauptfensterWindowClass::BildLinksDrehenSignalHandler()
{
  EditierspalteEventBox->EditierspalteElementLinksDrehen();
}  // BildLinksDrehenSignalHandler


void HauptfensterWindowClass::BildBetrachtenSignalHandler()
{
 EditierspalteEventBox->EditierspalteElementBetrachten();
}  // BildBetrachtenSignalHandler


void HauptfensterWindowClass::BildBearbeitenSignalHandler()
{
 EditierspalteEventBox->EditierspalteElementEditieren();
}  // BildBearbeitenSignalHandler


void HauptfensterWindowClass::BenutzerInformierenSignalHandler()
{
 Gtk::AboutDialog UeberDialog;
 UeberDialog.set_program_name("PickSort");
 UeberDialog.set_version("v0.4");
 UeberDialog.set_copyright("Copyright (c) Andreas Eichendorf 08/2014");
 UeberDialog.set_comments(_("Program allows to sort large JPEG collections by drag n' drop operations.\nOnly basic and sustainable storage mechanism are used,\ne.g. directories, filenames sorted in alphabetic order, basic Exif-tags."));
 UeberDialog.set_license("\nPickSort is free software: you can redistribute it and/or modify it\n"
                         "under the terms of the GNU General Public License as published by\n"
                         "the Free Software Foundation, either version 3 of the license, or\n"
                         "any later version.\n\n"
                         "PickSort is distributed in the hope that it will be useful, but\n"
                         "WITHOUT ANY WARRANTY; without even the implied warranty of\n"
                         "MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.\n\n"
                         "See the GNU General Public License for more details.");
 UeberDialog.set_logo(GenerellesPixelbufferRB); 
 UeberDialog.run();
}  // BenutzerInformierenSignalHandler


void HauptfensterWindowClass::BenutzerEinweisenSignalHandler()
{
 char Befehl[300];
 char Verzeichnis[200];
 strcpy(Befehl,"firefox ");
 char* Dummy = getcwd(Verzeichnis, 200);
 strcat(Befehl, Verzeichnis);
 strcat(Befehl, "/PickSort-Handbuch.html");
 int Fehler = system(Befehl);
 if (Fehler)
  {
   Gtk::MessageDialog *BenutzerDialog =
    new Gtk::MessageDialog(_("Cannot find user manual"), false, Gtk::MESSAGE_WARNING, Gtk::BUTTONS_OK, true);
   BenutzerDialog->set_secondary_text(_("System call reports a problem."));
   BenutzerDialog->run();
   delete BenutzerDialog;
  }
}  // BenutzerEinweisenSignalHandler


bool HauptfensterWindowClass::SchliessenRueckfrageNotwendig()
{
 std::vector<bool>::iterator BoolIterHinWeg;
 std::vector<bool>::iterator BoolIterUmSort;
 std::vector<EditierspalteEventBoxClass*>::iterator BoxIter;
 
 for (BoolIterHinWeg = GenerellesEditierspalteHingeschoben.begin(),
      BoolIterUmSort = GenerellesEditierspalteUmsortiert.begin(),
      BoxIter = EditierspalteEventBoxSpeicher.begin();
      BoxIter != EditierspalteEventBoxSpeicher.end();
      ++BoolIterHinWeg,
      ++BoolIterUmSort,
      ++BoxIter)
  {
   if ((*BoolIterHinWeg || *BoolIterUmSort || (**BoxIter).GetUmbenanntUmbewertetGedreht())
       && !(**BoxIter).GetSpalteIstLeer())
    {
     return true;
    }
  }
 return false;
}  // SchliessenRueckfrageNotwendig


/*
 * PickSortHauptfenster.cpp **********************************************************************************
 */
 