/*
 *************************************************************************************************************
 * PickSortHauptfenster.h       
 *
 * Das Hauptfenster von PickSort: Kopfzeile, Menue, Fortschrittsbalken.
 *
 * Copyright (C) Andreas Eichendorf 2014 <PickSort@Andreas-Petra.de>            
 *************************************************************************************************************
 */


#ifndef PICKSORTHAUPTFENSTER_H
#define PICKSORTHAUPTFENSTER_H

#include <gtkmm.h> 
#include <iostream>
#include <stdlib.h>

#include "PickSortEditierspalte.h"
#include "PickSortElement.h"
#include "PickSortGenerelles.h"


class HauptfensterWindowClass : public Gtk::Window, public GenerellesClass  
{
 public:
  HauptfensterWindowClass();
  virtual ~HauptfensterWindowClass();
 protected:
  // Hauptmenue:  
  Glib::RefPtr<Gtk::UIManager> HauptfunktionenUIManager;
  Glib::RefPtr<Gtk::ActionGroup> HauptfunktionenActionGroup;
  Glib::RefPtr<Gtk::Action> VerzeichnisNeuAction;  
  Glib::RefPtr<Gtk::Action> VerzeichnisLadenAction;
  Glib::RefPtr<Gtk::Action> VerzeichnisSpeichernAction;
  Glib::RefPtr<Gtk::Action> SpalteFilternAction;
  Glib::RefPtr<Gtk::Action> SpalteSortierenAction;
  Glib::RefPtr<Gtk::Action> SpalteBenennenAction;
  Glib::RefPtr<Gtk::Action> SpaltePraesentierenAction;
  Glib::RefPtr<Gtk::Action> BildRechtsDrehenAction;
  Glib::RefPtr<Gtk::Action> BildLinksDrehenAction;
  Glib::RefPtr<Gtk::Action> BildBetrachtenAction;
  Glib::RefPtr<Gtk::Action> BildBearbeitenAction;
  Glib::RefPtr<Gtk::Action> BenutzerInformierenAction;  
  Glib::RefPtr<Gtk::Action> BenutzerEinweisenAction; 
  Gtk::Widget* HauptfunktionenMenubar;
 // Popup-Menue:
  Gtk::Menu PopupMenue;
  Gtk::MenuItem VerzeichnisSpeichernMenuItem;
  Gtk::MenuItem SpalteBenennenMenuItem;
  Gtk::MenuItem BildBetrachtenMenuItem;
  Gtk::MenuItem BildBearbeitenMenuItem;
 // Weitere Fensterelemente:
  Gtk::EventBox HauptfensterPopupEventBox;  
  Gtk::Grid HauptfensterGrid;  
  Gtk::Grid EditierfeldGrid;
  std::vector<EditierspalteEventBoxClass*> EditierspalteEventBoxSpeicher;
  EditierspalteEventBoxClass *EditierspalteEventBox;
  // Signalhaendler fuer die rechte Mausttaste:
  virtual bool PopupSignalHandler(GdkEventButton* Event);
  // Ende-Signalhandler wegen Rueckfragen an den Benutzer:
  virtual bool HauptfensterWindowSchliessenSignalHandler(GdkEventAny* Event);
  // Signalhandler des Hauptmenues und des Popupmenues:
  virtual void VerzeichnisNeuSignalHandler();
  virtual void VerzeichnisLadenSignalHandler();
  virtual void VerzeichnisSpeichernSignalHandler();
  virtual void SpalteFilternSignalHandler();
  virtual void SpalteSortierenSignalHandler();
  virtual void SpalteBenennenSignalHandler();
  virtual void SpaltePraesentierenSignalHandler();
  virtual void BildBetrachtenSignalHandler();
  virtual void BildRechtsDrehenSignalHandler();
  virtual void BildLinksDrehenSignalHandler();
  virtual void BildBearbeitenSignalHandler();
  virtual void BenutzerInformierenSignalHandler();
  virtual void BenutzerEinweisenSignalHandler();
 private:
  // Beim Schliessen der Anwendung muss vorab geprüft werden, ob nicht Vorarbeiten verfallen wuerden.
  // Dies muss dann beim Benutzer nachgefragt werden. Hier private Funktion wegen einfacherem Aufbau:
  bool SchliessenRueckfrageNotwendig();
};  // class HauptfensterWindowClass


#endif  // PICKSORTHAUPTFENSTER_H

/*
 * PickSortHauptfenster.h ************************************************************************************
 */
