/*
 *************************************************************************************************************
 * PickSortProFilehandling.h       
 *
 * Fileinteraktionen fuer das Projektorprogramm plus Grafikaufbereitung in Nebenzeit.
 *
 * Copyright (C) Andreas Eichendorf 2014 <PickSort@Andreas-Petra.de>            
 *************************************************************************************************************
 */


#ifndef PICKSORPROFILEHANDLING_H
#define PICKSORPROFILEHANDLING_H

#include <iostream>
#include <fstream>
#include <string>
#include <vector>

#include <Magick++.h>


class PickSortProFilehandlingClass
{
 public:
  PickSortProFilehandlingClass(const std::string& DatenfileName, int BildschirmBreite, int BildschirmHoehe);
  virtual ~PickSortProFilehandlingClass();
  // GeterstesBild immer am Anfang mindestens einmal geben:
  Magick::Blob GetErstesBild();
  Magick::Blob GetNaechstesBild();
  Magick::Blob GetVorherigesBild();
  // Nachladeroutine: In Nebenzeit Files nachladen. Immer nach einer Get...Bild-Funktion geben:
  void BilderNachladen();
 private:
  int BreiteBildschirm;
  int HoeheBildschirm;
  std::vector<std::string> FileNamensVektor;
  std::vector<std::string>::iterator FileNamensIterator;
  int FileNamensVeraenderung;
  Magick::Blob AktuellerBlob;
  Magick::Blob NaechsterBlob;
  Magick::Blob VorherigerBlob;
  unsigned int GetAnzahlBilder();
  Magick::Blob GetBild(std::string& Bildfile, int BildschirmBreite, int BildschirmHoehe);
};  // PickSortProFilehandlingClass


#endif  // PICKSORPROFILEHANDLING_H


/*
 * PickSortProFilehandling.h *********************************************************************************
 */

