/*
 *************************************************************************************************************
 * PickSort: main.cc
 * Copyright (C) 2014 Andreas Eichendorf <PickSort@Andreas-Petra.de>
 * 
 * PickSort is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * any later version.
 * 
 * PickSort is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 *************************************************************************************************************
 */


#include <gtkmm.h>

#include "PickSortGenerelles.h"
#include "PickSortHauptfenster.h"


int main (int argc, char *argv[])
{
 std::cerr << "PickSort v0.4.2 by Andreas Eichendorf 08/2014 - 09/2015" << std::endl;
 // Internationalisierung fuer Arme: Sprache in der Kommandozeile angeben, es gibt z.Z. DE und EN:
 if(argc == 1)
  {
   InterPhrasen.SetInterSprache(GenerellesInternationalisierungClass::SpracheDE);
  }
 else
  {
   if (!strcmp(argv[1], "EN"))
    {   
     InterPhrasen.SetInterSprache(GenerellesInternationalisierungClass::SpracheEN);
    }
   else
    {
     InterPhrasen.SetInterSprache(GenerellesInternationalisierungClass::SpracheDE);
    }
  }
 // argc auf 1 setzen, sonst wird der Fehler
 // "GLib-GIO-CRITICAL **: This application can not open files."
 // ueber das Terminal gemeldet:
 argc = 1;
 // Gtkmm-System aktivieren: (RefPtr deallokiert sich am Ende selbst.)
 Glib::RefPtr<Gtk::Application> Programm = Gtk::Application::create(argc, argv, "PickSort.by.Andreas.Eichendorf");
 // Das Hauptfenster instanzieren:
 HauptfensterWindowClass HauptfensterWindow;
 // Das Gtk-Polling starten:
 return Programm->run(HauptfensterWindow);
}  // main


/*
 * main.cc ***************************************************************************************************
 */

